设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 60|回复: 3

[求助] 【已解决】如何在UCS的Z轴为负的情况下正确entmake图元

[复制链接]
发表于 2021-10-11 15:03:43 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 13808843088 于 2021-10-11 16:27 编辑

有如下代码,执行tt后,得到红色点不正确。经分析,因为其坐标系为顺时针。
我的原意是输入UCS坐标,得到图元所在平面的法向量ocs,entmake图元时将坐标转为WCS,最后将210组码设置为ocs。
在坐标系为逆时针时都是正确的,但当坐标系为顺时针时就不对了。
不知是否因为我对autocad坐标系统的理解有误?哪位朋友帮忙分析一下,谢谢
  1. ;;;pt为UCS坐标
  2. (defun make-point (pt / ocs)
  3.   (setq ocs (trans '(0 0 1) 1 0 t))
  4.   (entmakex (list '(0 . "POINT")
  5.                   (cons 10 (trans pt 1 ocs))
  6.                   (cons 210 ocs)
  7.             )
  8.   )
  9. )
  10. (defun c:tt ()
  11.   (setvar "osmode" 0)
  12.   (command "ucs" "w")
  13.   (command "ucs" "3" '(1 1 0) '(1 2 0) '(2 1 0))
  14.   (setq pt (getpoint))
  15.   (setvar "cecolor" "1")
  16.   (make-point pt)
  17.   (command "ucs" "w")
  18.   (command "ucs" "3"'(1 1 0) '(2 1 0) '(1 2 0))
  19.   (setq pt (getpoint))
  20.   (setvar "cecolor" "2")
  21.   (make-point pt)
  22. )
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
 楼主| 发表于 2021-10-11 16:26:43 | 显示全部楼层
在麦叔的指导下解决了,点没有面的性质,210没用
  1. ;;;pt为UCS坐标
  2. (defun make-point (pt /)
  3.   (entmakex (list '(0 . "POINT")
  4.                   (cons 10 (trans pt 1 0))
  5.             )
  6.   )
  7. )
  8. (defun c:tt ()
  9.   (setvar "osmode" 0)
  10.   (command "ucs" "w")
  11.   (command "ucs" "3" '(1 1 0) '(1 2 0) '(2 1 0))
  12.   (setq pt (getpoint))
  13.   (setvar "cecolor" "1")
  14.   (make-point pt)
  15.   (command "ucs" "w")
  16.   (command "ucs" "3"'(1 1 0) '(2 1 0) '(1 2 0))
  17.   (setq pt (getpoint))
  18.   (setvar "cecolor" "2")
  19.   (make-point pt)
  20. )

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 4028个

财富等级: 富可敌国

发表于 6 天前 | 显示全部楼层
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 3763个

财富等级: 富可敌国

发表于 6 天前 | 显示全部楼层
做一个热心并受欢迎的人
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-10-21 18:47 , Processed in 0.826821 second(s), 34 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表